HDU 4336 Card Collector(狀態壓縮+概率DP)

傳送門

In your childhood, do you crazy for collecting the beautiful cards in the snacks? They said that, for example, if you collect all the 108 people in the famous novel Water Margin, you will win an amazing award.

As a smart boy, you notice that to win the award, you must buy much more snacks than it seems to be. To convince your friends not to waste money any more, you should find the expected number of snacks one should buy to collect a full suit of cards.
 

Input
The first line of each test case contains one integer N (1 <= N <= 20), indicating the number of different cards you need the collect. The second line contains N numbers p1, p2, …, pN, (p1 + p2 + … + pN <= 1), indicating the possibility of each card to appear in a bag of snacks.

Note there is at most one card in a bag of snacks. And it is possible that there is nothing in the bag.
 

Output
Output one number for each test case, indicating the expected number of bags to buy to collect all the N different cards.

You will get accepted if the difference between your answer and the standard answer is no more that 10^-4.
 

Sample Input
1 0.1 2 0.1 0.4
 

Sample Output
10.000 10.500

題目大意:

還記得小時候喫的乾脆面嗎,乾脆麪包裏面有一個卡片,我們收集一套卡片需要喫好多的乾脆面,現在一套卡片有 N 張,現在給出一包乾脆面裏出現第 ai 種卡片的概率爲 pi ,現在求喫多少包乾脆面才能收集一套卡片,也就是求收集一套卡片的期望包數。

解題思路:

因爲卡片出現的概率不一樣,所以沒有辦法直接求,那麼觀察數據範圍 N20 ,那麼可以考慮狀態壓縮,設 dp[i]: i  1  , 那麼有如下公式成立:

dp[i]=p1dp[i]+i&(1<<k)=0dp[i|(1<<k)]

其中 p1 表示+0
解釋一下:假設 i=6 ,那麼有它的二進制表示爲 110 ,顯然它已經有第 1 和 第 2 種卡片,所以 dp[6]=(+p[1]+p[2])dp[6]+p[3]dp[7]

初始化 dp[(1<<n)1]=0

代碼:

#include <iostream>
#include <string.h>
#include <string>
#include <algorithm>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <map>
using namespace std;
typedef long long LL;
const int MAXN = 1048576+5;
const double PI = acos(-1);
const double eps = 1e-8;
const LL MOD = 1e9+7;
double dp[MAXN], p[22];
int main(){
    //freopen("C:/Users/yaonie/Desktop/in.txt", "r", stdin);
    //freopen("C:/Users/yaonie/Desktop/out.txt", "w", stdout);
    int n;
    while(~scanf("%d", &n)){
        p[0] = 0;
        double t = 1;//包裏表示沒有卡的概率
        for(int i=0; i<n; i++) scanf("%lf",&p[i]), t -= p[i];
        int all = (1<<n);
        dp[all-1] = 0;
        for(int i=all-2; i>=0; i--){
            double t1 = 0, t2 = 0;
            for(int j=0; j<n; j++){
                if(i&(1<<j)) t2 += p[j];
                else t1 += p[j]*dp[i|(1<<j)];
            }
            dp[i] = (t1+1)/(1-t2-t);
        }
        printf("%.5f\n",dp[0]);
    }
    return 0;
}
發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章